import tabelib
import os.path
import sys
from ExtensionClass import Base
from string import split, join, lower
import thread
import array
import re
#import perl
from Products.PluginIndexes.TextIndex.Splitter.ZopeSplitter import ZopeSplitter

csplitter_lock=thread.allocate_lock()
none_en_eraser = re.compile('[\xa0-\xff]')

mod_dir = os.path.split(sys.argv[0])[0] or '.'
tsidb_path = os.path.join(mod_dir, 'tsi.db');

# default for older objects
stop_syn={}

class CSplitter:
    """ First try at a Chinese-capable Splitter. """

    def __init__(self, doc, stop_syn=None, encoding='latin-1', singlechar=0, indexnumbers=0, maxlen=32, casefolding=0):
        #print tsidb_path
        
        # process none english data
        all_en = none_en_eraser.sub(' ', doc)
	sp = ZopeSplitter(all_en, stop_syn, encoding, singlechar, indexnumbers, maxlen, casefolding)
	ec = sp.split()
        #etext = lower( join(ec, ' ') )
        #print 'etext:'+etext
        
        if stop_syn is None:
            self.stop_syn = {}
        else:
            self.stop_syn = stop_syn
        self.encoding = encoding
        self.singlechar = singlechar
        self.indexnumbers = indexnumbers
        self.maxlen = maxlen
        self.casefolding = casefolding
        
	# To split chinese word by libtabe
	doc_big5 = unicode(doc, "utf-8").encode("big5_tw");
        csplitter_lock.acquire() # lib is not thread-safe
        c=split(tabelib.sparse_tostr(doc_big5, tsidb_path), ' ');
        csplitter_lock.release()
        
        cc=filter(lambda x: x != 'EOS' and x != '', c)
        text = join(cc, ' ')
        if len(text) > 0:
            text_utf8 = unicode(text,"big5_tw").encode("utf-8");
            cc_u = split(text_utf8, ' ')
            #print 'ctext:'+text
        
        keywords=[]
        if len(text) > 0:
	   keywords.extend(cc_u)
	keywords.extend(ec)

        self.keywords=keywords
        self.unparsed=join(keywords, ' ')
        #print self.unparsed

    def __getslice__(self, a, b):
        return self.keywords[a:b]

    def __getitem__(self, a):
        return self.keywords[a]

    def __len__(self):
        return len(self.keywords)

    def indexes(self, a):
        res=[]
        for i in range(len(self)):
                 if self[i]==a:
                    res.append(i)
        return res

    def pos(self, a):
        i=int(a/2)
        x=self.unparsed.find(self[i])
        return (x,x+len(self[i]))

    def split(self):
        return self.keywords

from Products.ZCTextIndex.ISplitter import ISplitter
from Products.ZCTextIndex.PipelineFactory import element_factory
from unicodedata import category

default_encoding = "UTF-8"      # encoding to assume non-Unicode text to have
nonmappable_handling = "strict" # "strict", "ignore", or "replace";

def isCJK(ch):
    """...is CJK character?"""
    return category(ch) in ["Lo"]           # "Letter, Other" seems to be CJK stuff                                                                             

def isletnum(ch):
    """...is letter or number?"""
    return category(ch)[0] in ['L', 'N']

class ZCTextIndex_CSplitter:

    __implements__ = ISplitter
   
    def process(self, text, isGlob=0):
        isCJKWord = 0
        words = []
        word = u""

        if type(text) in [type([]), type(())]:
            text = " ".join(text)

        if type(text) == type(""):
            # convert to Unicode string
            text = unicode(text, default_encoding, nonmappable_handling)

        text_bg5 = text.encode("big5_tw");

        all_en = none_en_eraser.sub(' ', text_bg5)
	sp = ZopeSplitter(all_en, stop_syn, "latin-1", 0, 0, 32, 0)
	ec = sp.split()

        csplitter_lock.acquire() # lib is not thread-safe
        c=split(tabelib.sparse_tostr(text_bg5, tsidb_path), ' ');
        csplitter_lock.release()
        cc=filter(lambda x: x != 'EOS' and x != '', c)

        text_bg5_words = join(cc, ' ')
        if len(text_bg5_words) > 0:
            text_u = unicode(text_bg5_words, "big5_tw")
            cc_u = split(text_u, ' ')

        if len(cc) > 0:
	   words.extend(cc_u)
	words.extend(ec)

        return words

try:
  element_factory.registerFactory(
      "Word Splitter", "CSplitter", ZCTextIndex_CSplitter)
except ValueError:
  pass # this is probably caused by a refresh
